/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-08-01 15:32:38 UTC)
 * on 2013-08-01 at 18:48:49 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.admin.reports.model;

/**
 * JSON template for a usage report.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the Admin Reports API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class UsageReport extends com.google.api.client.json.GenericJson {

  /**
   * The date to which the record belongs.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String date;

  /**
   * Information about the type of the item.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private Entity entity;

  /**
   * The kind of object.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String kind;

  /**
   * Parameter value pairs for various applications.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.util.List<Parameters> parameters;

  static {
    // hack to force ProGuard to consider Parameters used, since otherwise it would be stripped out
    // see http://code.google.com/p/google-api-java-client/issues/detail?id=528
    com.google.api.client.util.Data.nullOf(Parameters.class);
  }

  /**
   * The date to which the record belongs.
   * @return value or {@code null} for none
   */
  public java.lang.String getDate() {
    return date;
  }

  /**
   * The date to which the record belongs.
   * @param date date or {@code null} for none
   */
  public UsageReport setDate(java.lang.String date) {
    this.date = date;
    return this;
  }

  /**
   * Information about the type of the item.
   * @return value or {@code null} for none
   */
  public Entity getEntity() {
    return entity;
  }

  /**
   * Information about the type of the item.
   * @param entity entity or {@code null} for none
   */
  public UsageReport setEntity(Entity entity) {
    this.entity = entity;
    return this;
  }

  /**
   * The kind of object.
   * @return value or {@code null} for none
   */
  public java.lang.String getKind() {
    return kind;
  }

  /**
   * The kind of object.
   * @param kind kind or {@code null} for none
   */
  public UsageReport setKind(java.lang.String kind) {
    this.kind = kind;
    return this;
  }

  /**
   * Parameter value pairs for various applications.
   * @return value or {@code null} for none
   */
  public java.util.List<Parameters> getParameters() {
    return parameters;
  }

  /**
   * Parameter value pairs for various applications.
   * @param parameters parameters or {@code null} for none
   */
  public UsageReport setParameters(java.util.List<Parameters> parameters) {
    this.parameters = parameters;
    return this;
  }

  @Override
  public UsageReport set(String fieldName, Object value) {
    return (UsageReport) super.set(fieldName, value);
  }

  @Override
  public UsageReport clone() {
    return (UsageReport) super.clone();
  }

  /**
   * Information about the type of the item.
   */
  public static final class Entity extends com.google.api.client.json.GenericJson {

    /**
     * Obfuscated customer id for the record.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String customerId;

    /**
     * Obfuscated user id for the record.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String profileId;

    /**
     * The type of item, can be a customer or user.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String type;

    /**
     * user's email.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String userEmail;

    /**
     * Obfuscated customer id for the record.
     * @return value or {@code null} for none
     */
    public java.lang.String getCustomerId() {
      return customerId;
    }

    /**
     * Obfuscated customer id for the record.
     * @param customerId customerId or {@code null} for none
     */
    public Entity setCustomerId(java.lang.String customerId) {
      this.customerId = customerId;
      return this;
    }

    /**
     * Obfuscated user id for the record.
     * @return value or {@code null} for none
     */
    public java.lang.String getProfileId() {
      return profileId;
    }

    /**
     * Obfuscated user id for the record.
     * @param profileId profileId or {@code null} for none
     */
    public Entity setProfileId(java.lang.String profileId) {
      this.profileId = profileId;
      return this;
    }

    /**
     * The type of item, can be a customer or user.
     * @return value or {@code null} for none
     */
    public java.lang.String getType() {
      return type;
    }

    /**
     * The type of item, can be a customer or user.
     * @param type type or {@code null} for none
     */
    public Entity setType(java.lang.String type) {
      this.type = type;
      return this;
    }

    /**
     * user's email.
     * @return value or {@code null} for none
     */
    public java.lang.String getUserEmail() {
      return userEmail;
    }

    /**
     * user's email.
     * @param userEmail userEmail or {@code null} for none
     */
    public Entity setUserEmail(java.lang.String userEmail) {
      this.userEmail = userEmail;
      return this;
    }

    @Override
    public Entity set(String fieldName, Object value) {
      return (Entity) super.set(fieldName, value);
    }

    @Override
    public Entity clone() {
      return (Entity) super.clone();
    }

  }

  /**
   * Model definition for UsageReportParameters.
   */
  public static final class Parameters extends com.google.api.client.json.GenericJson {

    /**
     * Boolean value of the parameter.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.Boolean boolValue;

    /**
     * RFC 3339 formatted value of the parameter.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private com.google.api.client.util.DateTime datetimeValue;

    /**
     * Integral value of the parameter.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key @com.google.api.client.json.JsonString
    private java.lang.Long intValue;

    /**
     * The name of the parameter.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String name;

    /**
     * String value of the parameter.
     * The value may be {@code null}.
     */
    @com.google.api.client.util.Key
    private java.lang.String stringValue;

    /**
     * Boolean value of the parameter.
     * @return value or {@code null} for none
     */
    public java.lang.Boolean getBoolValue() {
      return boolValue;
    }

    /**
     * Boolean value of the parameter.
     * @param boolValue boolValue or {@code null} for none
     */
    public Parameters setBoolValue(java.lang.Boolean boolValue) {
      this.boolValue = boolValue;
      return this;
    }

    /**
     * RFC 3339 formatted value of the parameter.
     * @return value or {@code null} for none
     */
    public com.google.api.client.util.DateTime getDatetimeValue() {
      return datetimeValue;
    }

    /**
     * RFC 3339 formatted value of the parameter.
     * @param datetimeValue datetimeValue or {@code null} for none
     */
    public Parameters setDatetimeValue(com.google.api.client.util.DateTime datetimeValue) {
      this.datetimeValue = datetimeValue;
      return this;
    }

    /**
     * Integral value of the parameter.
     * @return value or {@code null} for none
     */
    public java.lang.Long getIntValue() {
      return intValue;
    }

    /**
     * Integral value of the parameter.
     * @param intValue intValue or {@code null} for none
     */
    public Parameters setIntValue(java.lang.Long intValue) {
      this.intValue = intValue;
      return this;
    }

    /**
     * The name of the parameter.
     * @return value or {@code null} for none
     */
    public java.lang.String getName() {
      return name;
    }

    /**
     * The name of the parameter.
     * @param name name or {@code null} for none
     */
    public Parameters setName(java.lang.String name) {
      this.name = name;
      return this;
    }

    /**
     * String value of the parameter.
     * @return value or {@code null} for none
     */
    public java.lang.String getStringValue() {
      return stringValue;
    }

    /**
     * String value of the parameter.
     * @param stringValue stringValue or {@code null} for none
     */
    public Parameters setStringValue(java.lang.String stringValue) {
      this.stringValue = stringValue;
      return this;
    }

    @Override
    public Parameters set(String fieldName, Object value) {
      return (Parameters) super.set(fieldName, value);
    }

    @Override
    public Parameters clone() {
      return (Parameters) super.clone();
    }

  }

}
